CREATE TABLE dict1 (
       word                 CHAR(1) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict1
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict10 (
       word                 CHAR(10) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict10
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict11 (
       word                 CHAR(11) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict11
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict12 (
       word                 CHAR(12) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict12
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict16 (
       word                 CHAR(16) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict16
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict2 (
       word                 CHAR(2) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict2
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict3 (
       word                 CHAR(3) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict3
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict32 (
       word                 VARCHAR2(32) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict32
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict4 (
       word                 CHAR(4) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict4
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict5 (
       word                 CHAR(5) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict5
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict6 (
       word                 CHAR(6) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict6
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict7 (
       word                 CHAR(7) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict7
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict8 (
       word                 CHAR(8) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict8
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE dict9 (
       word                 CHAR(9) NOT NULL,
       url_id               NUMBER(12) NOT NULL,
       intag                NUMBER(2) NOT NULL
)
       PCTFREE 5
       PCTUSED 90
;


ALTER TABLE dict9
       ADD  ( PRIMARY KEY (word, url_id) ) ;


CREATE TABLE robots (
       hostinfo             VARCHAR2(127) NOT NULL,
       path                 VARCHAR2(127) NOT NULL
);


CREATE TABLE stopword (
       word                 VARCHAR2(32) NOT NULL,
       lang                 VARCHAR2(2) NOT NULL
);


ALTER TABLE stopword
       ADD  ( PRIMARY KEY (word, lang) ) ;


CREATE TABLE url (
       rec_id               NUMBER(12) NOT NULL,
       status               NUMBER(6) DEFAULT 0 NOT NULL,
       url                  VARCHAR2(128) NOT NULL,
       content_type         VARCHAR2(32) NULL,
       last_modified        VARCHAR2(32) NULL,
       title                VARCHAR2(128) NULL,
       txt                  VARCHAR2(255) NULL,
       docsize              NUMBER(12) NULL,
       last_index_time      NUMBER(12) NULL,
       next_index_time      NUMBER(12) NULL,
       referrer             NUMBER(12) DEFAULT 0 NOT NULL,
       tag                  NUMBER(6) DEFAULT 0 NOT NULL,
       hops                 NUMBER(6) DEFAULT 0 NOT NULL,
       keywords             VARCHAR2(255) NULL,
       description          VARCHAR2(100) NULL,
       crc                  VARCHAR2(33) NULL,
       lang                 VARCHAR2(2) NULL
)
       PCTFREE 5
       PCTUSED 90
;

CREATE UNIQUE INDEX XAK1url ON url
(
       url                            ASC
);

CREATE INDEX XIE1url ON url
(
       crc                            ASC
);

CREATE INDEX XIE2url ON url
(
       hops                           ASC
);


ALTER TABLE url
       ADD  ( PRIMARY KEY (rec_id) ) ;

CREATE VIEW dict (word, url_id, intag ) AS
SELECT word,url_id,intag 
FROM dict1
UNION ALL
SELECT word,url_id,intag 
FROM dict2
UNION ALL
SELECT word,url_id,intag 
FROM dict3
UNION ALL
SELECT word,url_id,intag  
FROM dict4
UNION ALL
SELECT word,url_id,intag  
FROM dict5
UNION ALL
SELECT word,url_id,intag  
FROM dict6
UNION ALL
SELECT word,url_id,intag  
FROM dict7
UNION ALL
SELECT word,url_id,intag  
FROM dict8
UNION ALL
SELECT word,url_id,intag  
FROM dict9
UNION ALL
SELECT word,url_id,intag 
FROM dict10
UNION ALL
SELECT word,url_id,intag  
FROM dict11
UNION ALL
SELECT word,url_id,intag  
FROM dict12
UNION ALL
SELECT word,url_id,intag  
FROM dict16
UNION ALL
SELECT word,url_id,intag  
FROM dict32
;


ALTER TABLE dict_old
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict1
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict10
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict11
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict12
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict16
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict2
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict3
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict32
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict4
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict5
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict6
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict7
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict8
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;


ALTER TABLE dict9
       ADD  ( FOREIGN KEY (url_id)
                             REFERENCES url
                             ON DELETE CASCADE ) ;



CREATE SEQUENCE next_url_id
   INCREMENT BY 1
   START WITH 1;


