#ifdef HAVE_MYSQL
#define ER_DUP_ENTRY            1062
#define CR_SERVER_LOST          2013
#define CR_SERVER_GONE_ERROR    2006
#define ER_SERVER_SHUTDOWN      1053
#endif

/* Database type */
#define DB_UNK			0
#define DB_MSQL			1
#define DB_MYSQL		2
#define DB_PGSQL		3
#define DB_SOLID		4
#define DB_ORACLE		5
#define DB_VIRT			6
#define DB_IBASE		7

extern char DBVersion[];
extern char *DBHost;
extern char *DBName;
extern char *DBUser;
extern char *DBPass;
extern int  DBPort;
extern int  DBType;
extern int  GMToffs;
extern int  have_targets;
extern int  index_started;
extern int  mark_done;
extern int  CurURLNumber;

extern int AddURL(INDEXER* Indexer,char *url,int referrer,int hops);
extern int DeleteWordFromURL(INDEXER* Indexer,int url_id);
extern int DeleteUrl(INDEXER* Indexer,int url_id);
extern int UpdateUrl(INDEXER* Indexer,int url_id,int status,int period);
extern char * escstr(char *x,char *y);

extern int LongUpdateUrl(INDEXER* Indexer,
	int url_id,int status,int is_changed,
	int size,int period,int hint,int index,
	char *last_modified_escaped,
	char *text_escaped,
	char *title_escaped,
	char *content_type,
	char *keywords_escaped,
	char *descript_escaped,
	char *digest,
	char *lang);

extern int StoreWords(INDEXER * Indexer, int url_id);
extern int AddHref(INDEXER *Indexer,char *href,int referrer,int hops,int stored);

extern int FindOrigin(INDEXER* Indexer,char *crc);
extern int UpdateClone(INDEXER* Indexer,int url_id,int status,int period,
	char *content_type,char *last_modified_escaped,char *digest);

extern int DeleteAllFromDict(INDEXER* Indexer);
extern int DeleteAllFromUrl(INDEXER* Indexer);
extern int DeleteRobotsFromHost(INDEXER* Indexer,char *hostinfo);
extern int AddRobotsToHost(INDEXER* Indexer,char *hostinfo,char *s);

extern STAT * GetStatistics();
extern char * DBErrorMsg(void *db);
extern int DBErrorCode(void *db);
extern char ** GetAllWordForms(void * db,char *word);
extern DOCUMENT * Find(void * db,char *q,int np,int ps, int mode,int sort_order,char *wordinfo,int *found);
extern DOCUMENT * CloneList(void * db,char *crc);
DOCUMENT *GetDocInfo(INDEXER* Indexer,int expired_first);
extern void * AllocDB();
extern void FreeDB(void * db);
extern int load_stop_list(void * db);
extern int load_affixes(void * db);
extern int load_spells(void * db);
extern STOP_WORD * IsStopWord(char *word);
extern int LoadRobots(INDEXER *Indexer);
extern void FreeDoc(DOCUMENT *Result);
extern int MarkForReindex(INDEXER* Indexer);
extern int StoreHrefs(INDEXER * Indexer);
extern void FreeHrefs();
extern void IncURLNumber();
extern int GetIndexedNumber();
extern int ClearDB(INDEXER* Indexer);


extern __INDLIB__ int AddTagLimit(int tag);
extern __INDLIB__ int AddStatusLimit(int status);
extern __INDLIB__ int AddURLLimit(char *URL);
extern __INDLIB__ int ClearLimits();
extern __INDLIB__ int ShowReferers(INDEXER* Indexer);
extern __INDLIB__ void SetMaxURLNumber(int n);


#ifdef HAVE_PTHREAD
extern __INDLIB__ int InitMutexes();
extern __INDLIB__ int DestroyMutexes();
extern __INDLIB__ int GetActive();
extern __INDLIB__ int IncActive();
extern __INDLIB__ int DecActive();
#define INC_ACC()	IncActive()
#define DEC_ACC()	DecActive()
#else
#define INC_ACC()
#define DEC_ACC()
#endif

int HTDBGet(INDEXER * Indexer,char *path,char *filename,char * htdb_list, char * htdb_doc,
		char *buf,int MaxDocSize);
