#ifndef _UDM_SYSLOG_H
#define _UDM_SYSLOG_H

#include "config.h"
#ifdef HAVE_SYSLOG_H
#include <syslog.h>
#endif


typedef struct _code {
        char    *c_name;
        int     c_val;
} CODE;

/* Verbose levels */
#define UDM_LOG_ERROR	1
#define WARNING		2
#define INFO		3
#define EXTRA		4
#define UDM_LOG_DEBUG	5


extern int LogFacility;
extern int syslog_facility(char *f);
extern int udm_openlog(int log2stderr);
extern void udm_log(int handle,int level, const char *fmt, ...);

extern void (*ThreadInfo)(int handle,char *state, char* str);
extern void (*StatInfo)(int handle, int code, int expired, int total, char* str);


__INDLIB__ void SetLogLevel(int level);

#endif
