/* Unix/Windows specific stuff */


#if (WIN32|WINNT)
extern void (*ThreadInfo)(int handle,char *state, char* str);
extern void (*StatInfo)(int handle, int code, int expired, int total, char* str);

#include "strcasecmp.h"
#define SIGALRM 13
#define UDMSLEEP(x)	_sleep(x*1000)
#define UDMALARM(x)
#define UDMFLASH(x)
#define UDMMEMZERO(a,b)	memset(a,0,b)
#define DUMP(x)

#define SHOWSTAT(h,a,b,c,d)	if(StatInfo)StatInfo(h,a,b,c,d)
#define REFERERINFO(h,x)
#define DELETEINFO(h,x)
#define IMPORTINFO(h,x)

#ifdef _CONSOLE
#define THREADINFO(h,s,m)       printf("Thread: %d %s %s\n", h,s,m)
#else
#define THREADINFO(h,s,m)       if(ThreadInfo)ThreadInfo(h,s,m)
#endif

#define SLASH		'\\'
#define __INDLIB__ __declspec(dllexport)
extern __INDLIB__ int SetThreadInfo(void (*_ThreadInfo)(int handle,char *state, char* str));
extern __INDLIB__ int SetStatInfo(void (*_StatInfo)(int handle,int code, int expired, int total, char* str));

extern void (*EnterCritSec)(int code);
extern void (*LeaveCritSec)(int code);
#ifdef HAVE_PTHREAD
#define LOCK_ROBOTS()		EnterCriticalSection(&robots_mutex)
#define UNLOCK_ROBOTS()		LeaveCriticalSection(&robots_mutex)
#define LOCK_HREFS(x)		EnterCriticalSection(&hrefs_mutex)
#define UNLOCK_HREFS(x)		LeaveCriticalSection(&hrefs_mutex)
#define LOCK_DOCS(x)		EnterCriticalSection(&docs_mutex)
#define UNLOCK_DOCS(x)		LeaveCriticalSection(&docs_mutex)
#define LOCK_ACTIVE()		EnterCriticalSection(&active_mutex)
#define UNLOCK_ACTIVE()		LeaveCriticalSection(&active_mutex)
#define LOCK_TARGET(x)		EnterCriticalSection(&target_mutex)
#define UNLOCK_TARGET(x)	LeaveCriticalSection(&target_mutex)
#define LOCK_INDEXED()		EnterCriticalSection(&indexed_mutex)
#define UNLOCK_INDEXED()	LeaveCriticalSection(&indexed_mutex)
#define LOCK_STARTUP(x)		EnterCriticalSection(&start_mutex)
#define UNLOCK_STARTUP(x)	LeaveCriticalSection(&start_mutex)
#define LOCK_MAIN()		EnterCriticalSection(&main_mutex)
#define UNLOCK_MAIN()		LeaveCriticalSection(&main_mutex)
#define LOCK_QUERY()		EnterCriticalSection(&query_mutex)
#define UNLOCK_QUERY()		LeaveCriticalSection(&query_mutex)
#define LOCK_HOST()
#define UNLOCK_HOST()
#else
#define LOCK_ROBOTS()
#define UNLOCK_ROBOTS()
#define LOCK_HREFS(x)
#define UNLOCK_HREFS(x)
#define LOCK_DOCS(x)
#define UNLOCK_DOCS(x)
#define LOCK_ACTIVE()
#define UNLOCK_ACTIVE()
#define LOCK_TARGET(x)
#define UNLOCK_TARGET(x)
#define LOCK_INDEXED()
#define UNLOCK_INDEXED()
#define LOCK_STARTUP(x)
#define UNLOCK_STARTUP(x)
#define LOCK_MAIN()
#define UNLOCK_MAIN()
#define LOCK_HOST()
#define UNLOCK_HOST()
#define LOCK_QUERY()
#define UNLOCK_QUERY()
#endif

#undef USE_PARSER
#else
#define UDMSLEEP(x)    		sleep(x)
#define UDMALARM(x)		alarm(x)
#define DUMP(x)			printf("%s;\n",x)
#define REFERERINFO(h,x)	printf("%s\n",x)
#define SHOWSTAT(h,a,b,c,d)	printf("%10d %10d %10d %s\n",a,b,c,d)
#define DELETEINFO(h,x)		printf("%s records\r",x)
#define IMPORTINFO(h,x)		printf("%s\n",x)

#define THREADINFO(h,s,m)	/*printf("THR_INF: %d '%s' '%s'\n",h,s,m);*/

#define UDMFLASH(x)		fflush(x)
#define UDMMEMZERO(a,b)		bzero(a,b)
#define SLASH		'/'
#define __INDLIB__

#ifdef HAVE_PTHREAD
#define LOCK_ROBOTS()		pthread_mutex_lock(&robots_mutex)
#define UNLOCK_ROBOTS()		pthread_mutex_unlock(&robots_mutex)
#define LOCK_HREFS(x)		pthread_mutex_lock(&hrefs_mutex)
#define UNLOCK_HREFS(x)		pthread_mutex_unlock(&hrefs_mutex)
#define LOCK_DOCS(x)		pthread_mutex_lock(&docs_mutex)
#define UNLOCK_DOCS(x)		pthread_mutex_unlock(&docs_mutex)
#define LOCK_ACTIVE()		pthread_mutex_lock(&active_mutex)
#define UNLOCK_ACTIVE()		pthread_mutex_unlock(&active_mutex)
#define LOCK_TARGET(x)		pthread_mutex_lock(&target_mutex)
#define UNLOCK_TARGET(x)	pthread_mutex_unlock(&target_mutex)
#define LOCK_INDEXED()		pthread_mutex_lock(&indexed_mutex)
#define UNLOCK_INDEXED()	pthread_mutex_unlock(&indexed_mutex)
#define LOCK_STARTUP(x)		pthread_mutex_lock(&start_mutex)
#define UNLOCK_STARTUP(x)	pthread_mutex_unlock(&start_mutex)
#define LOCK_MAIN()		pthread_mutex_lock(&main_mutex)
#define UNLOCK_MAIN()		pthread_mutex_unlock(&main_mutex)
#define LOCK_HOST()		pthread_mutex_lock(&host_mutex)
#define UNLOCK_HOST()		pthread_mutex_unlock(&host_mutex)
#define LOCK_QUERY()		pthread_mutex_lock(&query_mutex)
#define UNLOCK_QUERY()		pthread_mutex_unlock(&query_mutex)
#else
#define LOCK_ROBOTS()
#define UNLOCK_ROBOTS()
#define LOCK_HREFS(x)
#define UNLOCK_HREFS(x)
#define LOCK_DOCS(x)
#define UNLOCK_DOCS(x)
#define LOCK_ACTIVE()
#define UNLOCK_ACTIVE()
#define LOCK_TARGET(x)
#define UNLOCK_TARGET(x)
#define LOCK_INDEXED()
#define UNLOCK_INDEXED()
#define LOCK_STARTUP(x)
#define UNLOCK_STARTUP(x)
#define LOCK_MAIN()
#define UNLOCK_MAIN()
#define LOCK_HOST()
#define UNLOCK_HOST()
#define LOCK_QUERY()
#define UNLOCK_QUERY()
#endif

#endif

