#define BASE64_LEN(len) (4 * (((len) + 2) / 3) +2)

#define HTTP_STATUS_UNKNOWN		0
#define HTTP_STATUS_OK			200
#define HTTP_STATUS_REDIRECT		301
#define HTTP_STATUS_NOT_MODIFIED	304
#define HTTP_STATUS_DELETE		400
#define HTTP_STATUS_RETRY		503

#define HTTP_STATUS_BAD_REQUEST		400
#define HTTP_STATUS_UNAVAIL		503
#define HTTP_STATUS_TIMEOUT		504
#define HTTP_STATUS_NOT_SUPPORTED	505

#define UDM_NET_ERROR			-1
#define UDM_NET_TIMEOUT			-2
#define UDM_NET_CANT_CONNECT		-3
#define UDM_NET_CANT_RESOLVE		-4
#define UDM_NET_UNKNOWN			-5

#define UDM_MIRROR_NO			-1
#define UDM_MIRROR_YES			0
#define UDM_MIRROR_NOT_FOUND		-1
#define UDM_MIRROR_EXPIRED		-2
#define UDM_MIRROR_CANT_BUILD		-3
#define UDM_MIRROR_CANT_OPEN		-4


extern void base64_encode (const char *s, char *store, int length);
extern int open_host(char *hostname,int port,int timeout);
extern int HTTPResponseType(int status);
extern char *HTTPErrMsg(int code);
extern int FILEGet(char *header,char *dist,int maxsize);
extern int HTTPGet(char *host,int port,char *header,
	char *dist,int maxsize,int read_timeout);
extern int NEWSGet(char *host,int port,char *header,
	char *dist,int maxsize,int read_timeout);
extern int NNTPGet(char *host,int port,char *header,
	char *dist,int maxsize,int read_timeout);
extern int AddType(char * mime_type,char *reg);
extern void FreeTypes();

extern char *MirrorRoot;
extern char *MirrorHeadersRoot;
extern int   use_mirror;
extern int   build(char *path, mode_t omode);
extern int   MirrorPUT(char *schema, char *hostname, char *path,
		char *filename, char *header, char *content, int size, char *errmsg);
extern int   MirrorGET(char *schema, char *hostname, char *path,
		char *filename, char *buf, int MaxDocSize, int days, char *errmsg);

typedef struct mime_struct {
	regex_t	reg;
	char	*mime_type;
} MIME;

