#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "common.h"
#include "dbms.h"

#define HSIZE           256

static	HREF*	Href=NULL;
static	int mhrefs=0;
static	int nhrefs=0;

int AddHref(INDEXER *Indexer,char *href,int referrer,int hops,int stored){
int i;
	if(!href[0])return(0);
	if(strlen(href)>MAXURLSIZE)return(0);
	LOCK_HREFS(Indexer);
	for(i=0;i<nhrefs;i++)
		if(!strcmp(Href[i].href,href)){
			Href[i].stored|=stored;
			UNLOCK_HREFS(Indexer);
			return(0);
		}
	if(nhrefs>=mhrefs){
		if(mhrefs){
			mhrefs+=HSIZE;
			Href=(HREF *)realloc(Href,mhrefs*sizeof(HREF));
		}else{
			mhrefs=HSIZE;
			Href=(HREF *)malloc(mhrefs*sizeof(HREF));
		}
	}
	Href[nhrefs].href=strdup(href);
	Href[nhrefs].referrer=referrer;
	Href[nhrefs].hops=hops;
	Href[nhrefs].stored=stored;
	nhrefs++;
	UNLOCK_HREFS(Indexer);
	return(0);
}
void FreeHrefs(){
int i;
	for(i=0;i<nhrefs;i++)free(Href[i].href);
		nhrefs=0;mhrefs=0;
	free_it(Href);
}
int StoreHrefs(INDEXER * Indexer){
int i;
	LOCK_HREFS(Indexer);
	for(i=0;i<nhrefs;i++){
		if(!(Href[i].stored)){
			AddURL(Indexer,Href[i].href,Href[i].referrer,Href[i].hops);
			if(DBErrorCode(Indexer->db)){
				UNLOCK_HREFS(Indexer);
				return(IND_ERROR);
			}
			Href[i].stored=1;
			LOCK_TARGET(Indexer);
			have_targets=1;
			UNLOCK_TARGET(Indexer);
		}
	}
	if(nhrefs>MAXHSIZE)FreeHrefs();
	UNLOCK_HREFS(Indexer);
	return(IND_OK);
}
